#include "lcars.h"
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

void print_file(int out, int fd, char * buf, int len);

void main(void) {
    int fd;
    int shared_idx;
    char *buf;
    int nbytes;
    char *shared_buf;
    int stdin_fd, stdout_fd;

    shared_buf = (char *) 0x3000000;

    nbytes = 0x100;

    shared_idx = allocate(nbytes);
    buf = shared_buf + shared_idx;


    stdin_fd = get_file("/dev/stdin");
    stdout_fd = get_file("/dev/stdout");
    write(stdout_fd, "########", 8);

    fd = get_file("root.key");
    print_file(stdout_fd, fd, buf, nbytes);
    write(stdout_fd, "########", 8);

    fd = get_file("flag1.papp");
    print_file(stdout_fd, fd, buf, nbytes);
    write(stdout_fd, "########", 8);

    fd = get_file("flag2.txt");
    print_file(stdout_fd, fd, buf, nbytes);
    write(stdout_fd, "########", 8);

    fd = get_file("flag3.txt");
    print_file(stdout_fd, fd, buf, nbytes);
    write(stdout_fd, "########", 8);
}

void print_file(int out, int fd, char * buf, int len) {
    int buflen;

    while ((buflen = read(fd, buf, len)) > 0)
    {
        write(out, buf, buflen);
    }
}

